<template>
<div>
    <v-app>
      <v-content>
        <div>
          <h2
            style="font-family: 'Avenir', Helvetica, Arial, sans-serif; padding-bottom: 20px; display: inline-block; ">Employees</h2>
          <v-btn flat color="blue-grey darken-3" style="padding-bottom: 7px" @click="dialog = true">
            <v-icon>library_add</v-icon>
          </v-btn>
        </div>
        <v-container fluid>
          <v-layout>
          <v-flex xm12>
            <v-text-field
              v-model="searchName"
              v-on:input="searchEmpsBy('name', searchName)"
              append-icon="search"
              label="Search by name"
              single-line
              hide-details
            ></v-text-field>
            </v-flex>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="searchSkill"
          append-icon="search"
          label="Search by skill"
          single-line
          hide-details
        ></v-text-field>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="searchProject"
          v-on:input="searchEmpsBy('project', searchProject)"
          append-icon="search"
          label="Search by project"
          single-line
          hide-details
        ></v-text-field>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="searchDepartment"
          v-on:input="searchEmpsBy('department',searchDepartment)"
          append-icon="search"
          label="Search by department"
          single-line
          hide-details
        ></v-text-field>
            </v-layout>
        </v-container>
        <v-card>
      <v-data-table
        :headers="headers"
        :items="items"
        :search="search"
      >
        <template v-slot:items="props">
          <tr @click="openEmployeeCard(props.item.id)">
           <td class="text-xs">{{ props.item.name }}</td>
           <td class="text-xs">{{ props.item.surname }}</td>
           <td class="text-xs">{{ props.item.position }}</td>
           <td class="text-xs">{{ props.item.project }}</td>
           <td class="text-xs">{{ props.item.department }}</td>
           <td class="text-xs">
             <!--{{ props.item.skills }}-->
             <div class="text-xs-center">
      <v-menu open-on-hover offset-y>
        <template v-slot:activator="{ on }">
          <v-btn


            flat
            v-on="on"
          >
            Show skills
          </v-btn>
        </template>
        <v-list>
          <v-list-tile
            v-for="(item, index) in dropdownSkills[getSkillsArrIndexById(props.item.id)]"
            :key="index"
            @click=""
          >
            <v-list-tile-title>{{ item.title }}</v-list-tile-title>
          </v-list-tile>
        </v-list>
      </v-menu>
    </div>
           </td>
          </tr>
        </template>
        <v-alert v-slot:no-results :value="true" color="error" icon="warning">
          Your search for "{{ search }}" found no results.
        </v-alert>
      </v-data-table>
    </v-card>
      </v-content>
      <v-dialog
        v-model="dialog"
        max-width="900">
        <v-card>
          <h2>Add new employee</h2>
          <v-card-text>
            <v-form>
              <v-flex>
                <v-text-field
                  v-model="newEmployee.name"
                  label="Name"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
                <v-text-field
                  v-model="newEmployee.surname"
                  label="Surname"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
                <v-text-field
                  v-model="newEmployee.startDate"
                  label="Start date"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
              <v-select
                v-model="newEmployee.gender"
                :items="genders"
                :menu-props="{ maxHeight: '400' }"
                label="Gender"
                persistent-hint>
              </v-select>
              </v-flex>
              <v-flex>
                <v-text-field
                  v-model="newEmployee.birthday"
                  label="Birthday"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
                <v-text-field
                  v-model="newEmployee.email"
                  label="Email"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
              <v-select
                v-model="newEmployee.skills"
                :items="employeeSkills"
                item-text="value.title"
                :menu-props="{ maxHeight: '400' }"
                label="Skills"
                multiple
                persistent-hint>
              </v-select>
              </v-flex>
                <v-flex>
                  <v-text-field
                    v-model="newEmployee.project"
                    label="Project"
                    required>
                  </v-text-field>
                </v-flex>
               <v-flex>
                  <v-text-field
                    v-model="newEmployee.jobTitle"
                    label="Job title"
                    required>
                  </v-text-field>
                </v-flex>
                <v-flex>
                  <v-text-field
                    v-model="newEmployee.department"
                    label="Department"
                    required>
                  </v-text-field>
                </v-flex>
              <v-flex>
                  <v-text-field
                    v-model="newEmployee.workplace"
                    label="Workplace"
                    required>
                  </v-text-field>
                </v-flex>
                <v-flex>
                  <v-text-field
                    v-model="newEmployee.position"
                    label="Position"
                    required>
                  </v-text-field>
                </v-flex>
              <v-flex>
                  <v-text-field
                    v-model="newEmployee.currentManager"
                    label="Current manager"
                    required>
                  </v-text-field>
                </v-flex>
              <v-flex>
                  <v-text-field
                    v-model="newEmployee.supervisor"
                    label="Supervisor"
                    required>
                  </v-text-field>
                </v-flex>
            </v-form>
          </v-card-text>
       <div align="center">
            <v-spacer></v-spacer>
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="dialog = false">
              Cancel
            </v-btn>
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="addNewEmployee">
              Save
            </v-btn>
       </div>
        </v-card>
      </v-dialog>
    </v-app>
  </div>
</template>

<script>
export default {
  name   : 'EmpsList',
  data () {
    return {
      genders         : ['Male', 'Female'],
      dialog          : false,
      search          : '',
      searchName      : '',
      searchSkill     : '',
      searchProject   : '',
      searchDepartment: '',
      headers         : [
        {text: 'Name', value: 'name', align: 'center'},
        {text: 'Surname', value: 'surname', align: 'center'},
        {text: 'Position', value: 'position', align: 'center'},
        {text: 'Project', value: 'project', align: 'center'},
        {text: 'Department', value: 'department', align: 'center'},
        {text: 'Skills', value: 'skills', align: 'center'}
      ],
      unfilteredItems : [],
      items           : [],
      employeeSkills  : [
        {value: {id: 4843, title: 'Skill1'}},
        {value: {id: 4845, title: 'Skill2'}},
      ],
      dropdownSkills  : [
        {title: 'Click Me'},
        {title: 'Click Me'},
        {title: 'Click Me'},
        {title: 'Click Me 2'}
      ],
      newEmployee     : {
        id            : '',
        name          : '',
        surname       : '',
        startDate     : '',
        gender        : '',
        birthday      : '',
        email         : '',
        skills        : [],
        project       : '',
        jobTitle      : '',
        department    : '',
        workplace     : '',
        position      : '',
        currentManager: '',
        supervisor    : ''
      }
    }
  },
  beforeMount () {
    let arr = this.$store.getters.getEmployees
    this.items = arr
    let len = arr.length
    // refill skills dropdowns array
    this.dropdownSkills = []
    for (let i = 0; i < len; i++) {
      if (arr[i].skills.length !== 0) {
        this.dropdownSkills.push(arr[i].skills)
      } else {
        let tmp = []
        tmp.push({title: 'No skills'})
        this.dropdownSkills.push(tmp)
      }
      this.unfilteredItems.push(this.items[i])
    };

    let skillsArr = this.$store.getters.getSkills;
    let skillsLen = skillsArr.length;

    this.employeeSkills = [];
    for(let i = 0; i < skillsLen; i++){
      this.employeeSkills.push({
        value: {id : skillsArr[i].id, title: skillsArr[i].title}
      })
    }

  },
  methods: {
    addNewEmployee () {
      // todo: make more good ID generation
      // todo: avoid creating empty employee!

      let skillsArr = []
      for (let i = 0; i < this.newEmployee.skills.length; i++) {
        skillsArr.push({
          id   : this.newEmployee.skills[i].id,
          title: this.newEmployee.skills[i].title,
          level: '1' // base level
        })
      }

      this.$store.commit('addEmployee', {
        data: {
          id            : Math.floor(Math.random() * 10000),
          name          : this.newEmployee.name,
          surname       : this.newEmployee.surname,
          startDate     : this.newEmployee.startDate,
          gender        : this.newEmployee.gender,
          birthday      : this.newEmployee.birthday,
          email         : this.newEmployee.email,
          skills        : skillsArr,
          project       : this.newEmployee.project,
          jobTitle      : this.newEmployee.jobTitle,
          department    : this.newEmployee.department,
          workplace     : this.newEmployee.workplace,
          position      : this.newEmployee.position,
          currentManager: this.newEmployee.currentManager,
          supervisor    : this.newEmployee.supervisor
        }
      })
      this.items = this.$store.getters.getEmployees;
      this.unfilteredItems = [];
      let len = this.items.length;
      for(let i = 0; i < len; i++){
        this.unfilteredItems.push(this.items[i]);
      }
      this.dialog = false;
    },
    openEmployeeCard (id) {
      this.$router.push('/main/employees/' + id)
    },
    getSkillsArrIndexById (id) {
      for (let i = 0; i < this.items.length; i++) {
        if (this.items[i].id === id) {
          return i
        }
      }
      return -1
    },
    // name , project, department, NOT skills
    searchEmpsBy (param, searchStr) {
      this.items = this.unfilteredItems
      if (!param) {
        return
      }
      if (!searchStr) {
        this.items = this.unfilteredItems
        return
      }
      let len = this.items.length
      let res = []
      for (let i = 0; i < len; i++) {
        if (this.items[i][param].includes(searchStr)) {
          res.push(this.items[i])
        }
      }
      this.items = res
    }
  }
}
</script>

<style scoped>
  h2 {
    font-family    : 'Avenir', Helvetica, Arial, sans-serif;
    padding-top    : 10px;
    padding-bottom : 20px;
    display        : inline-block;
  }
</style>
